(define rand-size 16)
(define state-path (create-temporary-file))
(on-exit (lambda () (delete-file* state-path)))

(test-assert "Requesting RNG init without error" (random-poll))
(test-assert "RNG is ready" (random-status))

(test-assert "Seeding with uninitialized memory"
             (begin (random-seed (make-blob rand-size)) #t))
(test-assert "Adding low-quality seed material with uninitialized memory"
             (begin (random-add (make-blob rand-size) 0.1) #t))

(test "Requesting random bytes" rand-size (blob-size (random-bytes rand-size)))
(test "Requesting random bytes" rand-size (blob-size (random-bytes rand-size)))
(test "Requesting random bytes" rand-size (blob-size (random-bytes rand-size)))

(test-assert "Suggested seed file path is a string"
             (string? (random-file-name)))
(test-assert "Saved seed to disk successfully"
             (begin (write-random-file state-path) #t))
(test-assert "Loaded seed from disk successfully"
             (begin (load-random-file state-path -1) #t))
